# SoTriangleStripSet Class Reference
[Nodes]

`#include <Inventor/nodes/SoTriangleStripSet.h>`

Inheritance diagram for SoTriangleStripSet:

List of all members.

## Detailed Description

The SoTriangleStripSet class is used to render and control non-indexed triangle strips.

Triangle strips are specified using the numVertices field. Coordinates, normals, materials and texture coordinates are fetched in order from the current state or from the vertexProperty node if set. For example, if numVertices is set to [3, 4, 5, 3], this node would specify a triangle from coordinates 0, 1 and 2, a triangle strip from coordinates 3, 4, 5 and 6, a triangle strip from coordinates 7, 8, 9, 10 and 11 and finally a triangle from coordinates 12, 13, 14.

Or to put it another way: in a tristrip there will always be two vertices more than there are triangles. Realize that you are handling data on the vertex level (not polygon-level), and that the triangles are laid out like this, given 5 vertices:

1-----3-----5 \ / \ / \ / \ / 2-----4

Strips are converted into triangles the way OpenGL does it, of course.

Binding PER_PART (per strip), PER_VERTEX, PER_FACE or OVERALL can be set for material, and normals. The default material binding is OVERALL. The default normal binding is PER_VERTEX.

## Public Member Functions

| SoTriangleStripSet (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SbBool | generateDefaultNormals (SoState *state, SoNormalBundle *nb)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFInt32 | numVertices

## Protected Member Functions

virtual | ~SoTriangleStripSet ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SbBool | generateDefaultNormals (SoState *, SoNormalCache *)

## Constructor & Destructor Documentation

SoTriangleStripSet::SoTriangleStripSet | ( | void |  | ) |

| Constructor.

SoTriangleStripSet::~SoTriangleStripSet | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void sogl_nits_m3_n3_t1 void SoTriangleStripSet::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNonIndexedShape.

void SoTriangleStripSet::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoTriangleStripSet::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

SbBool SoTriangleStripSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalBundle * | nb
| ) | `[virtual]`

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalBundle class. `TRUE` should be returned if normals were generated, `FALSE` otherwise.

Default method returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

void SoTriangleStripSet::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

void SoTriangleStripSet::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

SbBool SoTriangleStripSet::generateDefaultNormals | ( | SoState * | state,
|  | SoNormalCache * | nc
| ) | `[protected, virtual]`

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return `TRUE` if normals were generated, `FALSE` otherwise.

Default method just returns `FALSE`.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

## Member Data Documentation

SoMFInt32 SoTriangleStripSet::numVertices

| Specifies the number of vertices in each triangle strip. The vertices are fetched from the current coordinate node, or from the vertexProperty field if present.

The documentation for this class was generated from the following files:

- SoTriangleStripSet.h
- SoTriangleStripSet.cpp